package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.AimGroupInfo;
import com.izouma.awesomeadmin.service.AimGroupInfoService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/aimGroupInfo")
public class AimGroupInfoController {

    @Autowired
    private AimGroupInfoService aimGroupInfoService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(AimGroupInfo record) {
        List<AimGroupInfo> pp = aimGroupInfoService.getAimGroupInfoList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getAimGroupInfo", method = RequestMethod.GET)
    @ResponseBody
    public Result getAimGroupInfo(@RequestParam(required = false, value = "id") String id) {
        AimGroupInfo data = aimGroupInfoService.getAimGroupInfoById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(AimGroupInfo record) {
        AimGroupInfo data = aimGroupInfoService.getAimGroupInfo(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, AimGroupInfo record) {
        Map<String, Object> result = new HashMap<>();

        List<AimGroupInfo> pp =aimGroupInfoService.getAimGroupInfoByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(AimGroupInfo record) {
        boolean num = aimGroupInfoService.createAimGroupInfo(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateAimGroupInfo(AimGroupInfo record) {
        boolean num = aimGroupInfoService.updateAimGroupInfo(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteAimGroupInfo(AimGroupInfo record) {

        boolean num = aimGroupInfoService.deleteAimGroupInfo(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, AimGroupInfo record) throws Exception {

    List<AimGroupInfo> aimGroupInfos = aimGroupInfoService.getAimGroupInfoList(record);


        String sheetName = "aim_group_info";
        String titleName = "点标组数据表";
        String fileName = "点标组表";
        int columnNumber = 15;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "权限" ,   "城市ID" ,   "地标ID" ,   "区域ID" ,   "事物ID" ,   "点标组名称" ,   "点标模板" ,   "区域" ,   "备注"  };
        String[][] dataList = new String[aimGroupInfos.size()][15];

        for (int i = 0; i < aimGroupInfos.size(); i++) {

                        dataList[i][0] = String.valueOf(aimGroupInfos.get(i).getId());
                        dataList[i][1] = String.valueOf(aimGroupInfos.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(aimGroupInfos.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(aimGroupInfos.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(aimGroupInfos.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(aimGroupInfos.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(aimGroupInfos.get(i).getPower());
                        dataList[i][7] = String.valueOf(aimGroupInfos.get(i).getCityId());
                        dataList[i][8] = String.valueOf(aimGroupInfos.get(i).getLandmarkId());
                        dataList[i][9] = String.valueOf(aimGroupInfos.get(i).getAreaId());
                        dataList[i][10] = String.valueOf(aimGroupInfos.get(i).getThingId());
                        dataList[i][11] = String.valueOf(aimGroupInfos.get(i).getGroupName());
                        dataList[i][12] = String.valueOf(aimGroupInfos.get(i).getAimTemplateId());
                        dataList[i][13] = String.valueOf(aimGroupInfos.get(i).getUserArea());
                        dataList[i][14] = String.valueOf(aimGroupInfos.get(i).getRemark());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

